diff -Nru ./src/fl_boxtype.cxx ../fltk-2-cvs/src/fl_boxtype.cxx
--- ./src/fl_boxtype.cxx	Tue Feb 20 08:59:50 2001
+++ ../fltk-2-cvs/src/fl_boxtype.cxx	Tue Jul 10 20:31:37 2001
@@ -35,20 +35,33 @@
 
 ////////////////////////////////////////////////////////////////
 
-static void focus_rectangle(int x, int y, int w, int h, Fl_Color c) {
+#define focus_rectangle __focus_rectangle
+
+void __focus_rectangle(int x, int y, int w, int h, Fl_Color c) {
   if (h > 4 && w > 4) {
+    int t;
     fl_color(fl_contrast(FL_BLACK, c));
-    fl_line_style(FL_DOT);
-    fl_rect(x+1,y+1,w-2,h-2);
-    fl_line_style(0);
+    for(t=0; t<(w-2); t+=2) {
+      fl_point(x+t+1,y+1);
+    }
+    for(t=!(h&1); t<(w-2); t+=2) {
+      fl_point(x+t+1,y+h-2);
+    }
+    for(t=0; t<(h-2); t+=2) {
+      fl_point(x+1,y+t+1);
+    }
+    for(t=!(w&1); t<(h-2); t+=2) {
+      fl_point(x+w-2,y+t+1);
+    }      
   }
 }
 
 void Fl_No_Box::draw(const Fl_Widget*,
 		     int x, int y, int w, int h, Fl_Flags f) const {
   if (!(f & FL_FRAME_ONLY) && (f & FL_FOCUSED))
-    focus_rectangle(x,y,w,h,FL_GRAY);
+    focus_rectangle(x,y,w,h,FL_GRAY);    
 }
+
 Fl_No_Box::Fl_No_Box(const char* name) : Fl_Boxtype_(name) {
   dx_ = dy_ = dw_ = dh_ = 0;
   fills_rectangle_ = 0;
@@ -74,7 +87,7 @@
 ////////////////////////////////////////////////////////////////
 
 FL_API void fl_to_inactive(const char* s, char* to) {
-  if (*s == '2') *to++ = *s++;
+  if ((*s == '2')||(*s == '1')) *to++ = *s++;
   while (*s) *to++ = 'M'+(*s++ - 'A')/3;
   *to = 0;
 }
@@ -89,8 +102,9 @@
   char buf[26]; if (f&FL_INACTIVE && Fl_Style::draw_boxes_inactive) {
     fl_to_inactive(s, buf); s = buf;}
   if (h > 0 && w > 0) {
-    if (*s == '2') {s++; goto HACK;}
     for (;;) {
+      if (!*s) break;        
+      if ((*s=='2')||(*s=='1')) {s++; goto HACK2;}          
       // draw top line:
       fl_color(*s++ + (FL_GRAY_RAMP-'A'));
       fl_line(x, y, x+w-1, y);
@@ -99,8 +113,10 @@
       fl_color(*s++ + (FL_GRAY_RAMP-'A'));
       fl_line(x, y+h-1, x, y);
       x++; if (--w <= 0) break;
-      if (!*s) break;
-    HACK:
+      
+    HACK2:
+      if (!*s) break;    
+      if ((*s=='2')||(*s=='1')) {s++; continue;}
       // draw bottom line:
       fl_color(*s++ + (FL_GRAY_RAMP-'A'));
       fl_line(x, y+h-1, x+w-1, y+h-1);
@@ -109,7 +125,6 @@
       fl_color(*s++ + (FL_GRAY_RAMP-'A'));
       fl_line(x+w-1, y+h-1, x+w-1, y);
       if (--w <= 0) break;
-      if (!*s) break;
     }
   }
   if (!(f & FL_FRAME_ONLY)) {
@@ -127,18 +142,33 @@
 #ifdef _MSC_VER
 #pragma warning(disable: 4355) // quiet warning about using this as base class init
 #endif
+
 Fl_Frame_Box::Fl_Frame_Box(const char* n, const char* s, const Fl_Frame_Box* d)
   : Fl_Boxtype_(n), data_(s), down(d ? d : this)
 {
+
+#define INC_S if (!(*(++s))) break;
+
   fills_rectangle_ = 1;
-  int i = strlen(s)/2;
-  dw_ = dh_ = i;
-  i /= 2;
-  dx_ = dy_ = i;
+  dx_ = dy_ = dw_ = dh_ = 0;
+  while(1) {
+  
+    INC_S
+    if ((*s!='1')&&(*s!='2'))
+      {dx_++;dw_++;INC_S dy_++;dh_++;}
+      
+    INC_S
+    if ((*s!='1')&&(*s!='2'))
+      {dw_++;INC_S dh_++;}    
+  }
+  
+#undef INC_S
 }
 
-const Fl_Frame_Box fl_down_box("down", "2WWMMPPAA", &fl_up_box);
-const Fl_Frame_Box fl_up_box("up", "2AAWWMMTT", &fl_down_box);
+//const Fl_Frame_Box fl_down_box("down", "2WWMMPPAA", &fl_up_box);
+//const Fl_Frame_Box fl_down_box("down", "2WWAARRJJ", &fl_up_box);
+//const Fl_Frame_Box fl_up_box("up", "2AAWWMMTT", &fl_down_box);
+//const Fl_Frame_Box fl_up_box("up", "2AAWWJJRR", &fl_down_box);
 
 const Fl_Frame_Box fl_thin_down_box("thin down", "2WWHH", &fl_thin_up_box);
 const Fl_Frame_Box fl_thin_up_box("thin up", "2HHWW", &fl_thin_down_box);
@@ -196,6 +226,196 @@
 }
 
 const Fl_Boxtype_* Fl_Boxtype_::first = 0;
+
+static int hexnt2dec(char hex)
+{
+    if ((hex>='0')&&(hex<='9')) return hex-'0';
+    if ((hex>='A')&&(hex<='Z')) return hex-'A'+10;
+    if ((hex>='a')&&(hex<='z')) return hex-'a'+10+26;    
+    if (hex=='.') return -1;
+    return 0;
+}
+/*
+class FL_API Fl_Mappy_Box : public Fl_Boxtype_ {
+protected:
+  const char* data_;
+  int data_sz_x,data_sz_y;
+  int data_sl_x,data_sl_y;
+  char at(int x,int y);
+public:
+  const char* data() const {return data_;}
+  void draw(int,int,int,int, Fl_Color, Fl_Flags=0) const;
+  void draw(const Fl_Widget*, int,int,int,int, Fl_Flags=0) const;
+  Fl_Mappy_Box(const char* n, const char* c, const Fl_Frame_Box* d=0);
+};
+*/
+
+Fl_Mappy_Box::Fl_Mappy_Box(const char* n, const char* c, const Fl_Frame_Box* d=0)
+  : Fl_Frame_Box(n,"AAAA",d), data2_(c)
+{
+  dx_ = dy_ = dw_ = dh_ = 0;
+  fills_rectangle_ = 0;
+  data_sz_x = hexnt2dec(c[0]);
+  data_sz_y = hexnt2dec(c[1]);  
+  data_sl_x = hexnt2dec(c[2]);
+  data_sl_y = hexnt2dec(c[3]);  
+  dx_ = data_sl_x;
+  dy_ = data_sl_y;  
+  dw_ = data_sz_x - 1;
+  dh_ = data_sz_y - 1;  
+}
+
+int high_contrast_flag=0;
+static int hicontrast(int p)
+{
+    float z='W'-'A';
+    int t;    
+    p-='A';
+    for(t=0;t<high_contrast_flag;t++)
+    {
+        p=(int)(sin(p*3.14159265358*0.5/z)*z);
+    }
+    p+='A';
+    return p;
+}
+char Fl_Mappy_Box::at(int x,int y) const
+{
+  int p=(data2_+4)[data_sz_x*y+x];
+  if (high_contrast_flag) p=hicontrast(p);
+  return p;
+}
+
+void Fl_Mappy_Box::draw(int x, int y, int w, int h, Fl_Color c, Fl_Flags f=0) const
+{
+    int xx,yy;
+    if (f & FL_VALUE)
+    {
+        down->draw(x,y,w,h,c,f&(~FL_VALUE));
+        return;
+    }
+    
+    for(yy=0;yy<data_sl_y;yy++)    
+     for(xx=0;xx<data_sl_x;xx++)
+      if (at(xx,yy)!='.')
+       {fl_color(at(xx,yy) + (FL_GRAY_RAMP-'A'));fl_point(x+xx,y+yy);}
+      
+    for(yy=0;yy<data_sl_y;yy++)    
+     for(xx=data_sl_x+1;xx<data_sz_x;xx++)
+      if (at(xx,yy)!='.')
+       {fl_color(at(xx,yy) + (FL_GRAY_RAMP-'A'));
+        fl_point(x+w-data_sz_x+xx,y+yy);}
+
+    for(yy=data_sl_y+1;yy<data_sz_y;yy++)    
+     for(xx=0;xx<data_sl_x;xx++)
+      if (at(xx,yy)!='.')
+       {fl_color(at(xx,yy) + (FL_GRAY_RAMP-'A'));
+        fl_point(x+xx,y+h-data_sz_y+yy);}
+
+    for(yy=data_sl_y+1;yy<data_sz_y;yy++)    
+     for(xx=data_sl_x+1;xx<data_sz_x;xx++)
+      if (at(xx,yy)!='.')
+       {fl_color(at(xx,yy) + (FL_GRAY_RAMP-'A'));
+        fl_point(x+w-data_sz_x+xx,y+h-data_sz_y+yy);}
+
+
+
+    for(xx=0;xx<data_sl_x;xx++) {
+      fl_color(at(xx,data_sl_y) + (FL_GRAY_RAMP-'A'));
+      fl_line(x+xx,y+data_sl_y,
+              x+xx,y+h-dh_+2);
+    }
+
+    for(yy=0;yy<data_sl_y;yy++) {
+      fl_color(at(data_sl_x,yy) + (FL_GRAY_RAMP-'A'));
+      fl_line(x+data_sl_x,y+yy,
+              x+w-dw_+2,y+yy);
+    }
+    
+    for(xx=data_sl_x+1;xx<data_sz_x;xx++) {
+      fl_color(at(xx,data_sl_y) + (FL_GRAY_RAMP-'A'));
+      fl_line(x+w-data_sz_x+xx,y+data_sl_y,
+              x+w-data_sz_x+xx,y+h-dh_+2);
+    }
+
+    for(yy=data_sl_y+1;yy<data_sz_y;yy++) {
+      fl_color(at(data_sl_x,yy) + (FL_GRAY_RAMP-'A'));
+      fl_line(x+data_sl_x,y+h-data_sz_y+yy,
+              x+w-dw_+2,y+h-data_sz_y+yy);
+    }
+
+    
+    fl_color(at(data_sl_x,data_sl_y) + (FL_GRAY_RAMP-'A'));
+    fl_rectf(x+dx_,y+dy_,w-dw_,h-dh_);
+    if (f&FL_FOCUSED)
+    {
+        __focus_rectangle(x+dx_,y+dy_,w-dw_,h-dh_,at(data_sl_x,data_sl_y) + (FL_GRAY_RAMP-'A'));
+    }
+    
+}
+
+void Fl_Mappy_Box::draw(const Fl_Widget* widget, int x,int y,int w,int h, Fl_Flags f=0) const
+{
+    draw(x,y,w,h, widget->get_box_color(f), f);
+}
+
+const Fl_Mappy_Box fl_down_box("down", 
+"7733"
+
+"SAA" "A" "ASS"
+"AAJ" "J" "JJS"
+"AJS" "S" "SWJ"
+
+"AJS" "S" "SWS"
+
+"AJS" "S" "SWS"
+"SJW" "W" "WWS"
+"SSJ" "S" "SSS"
+
+,
+
+ &fl_up_box);
+
+const Fl_Mappy_Box __btn_down("__btn_down", 
+"7733"
+
+"SAA" "A" "ASS"
+"AAJ" "J" "JJS"
+"AJK" "K" "KWJ"
+
+"AJK" "K" "KWS"
+
+"AJK" "K" "KWS"
+"SJW" "W" "WWS"
+"SSJ" "S" "SSS"
+
+,
+
+ &fl_up_box);
+
+
+
+
+const Fl_Mappy_Box fl_up_box("up", 
+"7733"
+
+"SSS" "S" "JSS"
+"SWW" "W" "WJS"
+"SWS" "S" "SJA"
+
+"SWS" "S" "SJA"
+
+"JWS" "S" "SJA"
+"SJJ" "J" "JAA"
+"SSA" "A" "AAS"
+
+,
+
+ &__btn_down);
+
+
+
+
+
 
 //
 // End of "$Id: fl_boxtype.cxx,v 1.45 2001/02/20 06:59:50 spitzak Exp $".
